using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

namespace _42938CS
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			DataTable parentTable = GetParentTable();
			DataTable childTable = GetChildTable();

			DataSet ds = new DataSet();
			ds.Tables.AddRange(new DataTable[]{parentTable, childTable});
			DataRelation parentToChild = new DataRelation("ParentToChild", parentTable.Columns["parentID"], childTable.Columns["ParentID"]);
			ds.Relations.Add(parentToChild);
			this.gridGroupingControl1.DataSource = ds.Tables[0];

//			this.gridGroupingControl1.Table.RecordExpanding += new RecordEventHandler(Table_RecordExpanding);
		}

//		private void Table_RecordExpanding(object sender, RecordEventArgs e)
//		{
//			if(e.Record.GetRelatedChildTable(new RelationDescriptor("ParentToChild")).GetRecordCount() == 0)
//				e.Cancel = true;
//		}


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(8, 8);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(352, 264);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.62";
			this.gridGroupingControl1.RecordExpanding += new Syncfusion.Grouping.RecordEventHandler(this.gridGroupingControl1_RecordExpanding);
			this.gridGroupingControl1.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridGroupingControl1_QueryCellStyleInfo);
			// 
			// button1
			// 
			this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.button1.Location = new System.Drawing.Point(197, 280);
			this.button1.Name = "button1";
			this.button1.TabIndex = 1;
			this.button1.Text = "Expand All";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.button2.Location = new System.Drawing.Point(285, 280);
			this.button2.Name = "button2";
			this.button2.TabIndex = 2;
			this.button2.Text = "Collapse All";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(368, 310);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		#region Data Tables

		private int numberParentRows = 10;
		private int numberChildRows = 20;
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("SomethingEXIST"));
			dt.Columns.Add(new DataColumn("OPERATIONNO"));

			Random ran = new Random();
			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;
				dr[1] = ran.Next(100)%2;
				dr[2] = i;
				dt.Rows.Add(dr);
			}

			dt.PrimaryKey = new DataColumn[] { dt.Columns["parentID"]};

			return dt;
		}

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			dt.Columns.Add(new DataColumn("SomethingEXIST"));
			dt.Columns.Add(new DataColumn("Checked",typeof(bool)));
			Random ran = new Random();
			for(int i = 0; i < numberChildRows; ++i)
			{
				if((i % numberParentRows)>3)
				{
					DataRow dr = dt.NewRow();
					dr[0] = i.ToString();
					dr[1] = (i % numberParentRows).ToString();
					dr[2] = ran.Next(100)%2;;
					dr[3] = true;
					dt.Rows.Add(dr);
				}
			}
		
			return dt;
		}

		#endregion
		
		private void gridGroupingControl1_RecordExpanding(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(e.Record!= null && e.Record.NestedTables.Count>0 && e.Record.NestedTables[0].ChildTable.Records.Count == 0)
				e.Cancel = true;
		}

		private void gridGroupingControl1_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
			if (e.TableCellIdentity.TableCellType == GridTableCellType.RecordPlusMinusCell) 
			{ 
				Record r = e.TableCellIdentity.DisplayElement.ParentRecord as Record; 
				if (r != null && r.NestedTables.Count > 0 && r.NestedTables[0].ChildTable.Records.Count == 0) 
				{ 
					e.Style.CellType = "Static"; 
					e.Style.Borders.Bottom = new GridBorder(GridBorderStyle.Dotted);
					e.Style.Enabled = false;
					
					//Below code can be used insted of handling the RecordExpanding event
					//but it cause scrollbar flikering 
					//r.IsExpanded = false; 
				} 
			} 
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.Table.ExpandAllRecords();
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.Table.CollapseAllRecords();
		}
	}
}
